﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.IO;
using System.Linq;
using System.Runtime.InteropServices.WindowsRuntime;
using Windows.Foundation;
using Windows.Foundation.Collections;
using Windows.UI;
using Windows.UI.Xaml;
using Windows.UI.Xaml.Controls;
using Windows.UI.Xaml.Controls.Primitives;
using Windows.UI.Xaml.Data;
using Windows.UI.Xaml.Input;
using Windows.UI.Xaml.Media;
using Windows.UI.Xaml.Navigation;
using Syncfusion.UI.Xaml.Kanban;

// The Blank Page item template is documented at http://go.microsoft.com/fwlink/?LinkId=402352&clcid=0x409

namespace CustomSample
{
    /// <summary>
    /// An empty page that can be used on its own or navigated to within a Frame.
    /// </summary>
    public sealed partial class MainPage : Page
    {
        public MainPage()
        {
            this.InitializeComponent();
        }

        private void Kanban_OnCardTapped(object sender, KanbanTappedEventArgs e)
        {
            e.SelectedCard.BorderBrush = new SolidColorBrush(Colors.Blue);
            e.SelectedCard.BorderThickness = new Thickness(2);
        }
    }

    public class TaskDetails
    {
        public TaskDetails()
        {
            Tasks = new ObservableCollection<KanbanModel>();

            KanbanDataModel task = new KanbanDataModel();
            task.Title = "WINRT Issue";
            task.ID = "6593";
            task.Description = "Sorting is not working properly in DateTimeAxis";
            task.Category = "Open";
            task.ColorKey = "High";
            task.Tags = new string[] { "Bug Fixing" };
            task.ProgressValue = 20;
            Tasks.Add(task);

            task = new KanbanDataModel();
            task.Title = "Kanban Feature";
            task.ID = "25678";
            task.Description = "Need to prepare SampleBrowser sample";
            task.Category = "InProgress";
            task.ColorKey = "Low";
            task.Tags = new string[] { "New control" };
            task.ProgressValue = 48;
            task.ImageURL = new Uri("ms-appx:///images/icon.jpg");
            Tasks.Add(task);

            task = new KanbanDataModel();
            task.Title = "WPF Issue";
            task.ID = "29477";
            task.Description = "Nullreference exception in line chart";
            task.Category = "Review";
            task.ColorKey = "Normal";
            task.Tags = new string[] { "Bug Fixing" };
            task.ProgressValue = 25;
            Tasks.Add(task);

            task = new KanbanDataModel();
            task.Title = "Kanban Feature";
            task.ID = "27654";
            task.Description = "Need to prepare demo sample";
            task.Category = "Done";
            task.ColorKey = "Low";
            task.Tags = new string[] { "New control" };
            task.ProgressValue = 70;
            task.ImageURL = new Uri("ms-appx:///images/icon.jpg");
            Tasks.Add(task);
        }
        public ObservableCollection<KanbanModel> Tasks { get; set; }
    }

    public class KanbanDataModel : KanbanModel
    {
        private int _progressValue;

        public int ProgressValue
        {
            get
            {
                return _progressValue;
            }
            set
            {
                _progressValue = value;
            }
        }

    }

    public class VisibilityConverter : IValueConverter
    {
        public object Convert(object value, Type targetType, object parameter, string language)
        {
            var task = value as KanbanModel;
            if (task.ImageURL != null)
                return Visibility.Visible;
            return Visibility.Collapsed;
        }

        public object ConvertBack(object value, Type targetType, object parameter, string language)
        {
            throw new NotImplementedException();
        }
    }
}
